#ifndef SRC_HDF_FRICTIONALBOUNDARY_WRITER_HH
#define SRC_HDF_FRICTIONALBOUNDARY_WRITER_HH

#include <dune/fufem/boundarypatch.hh>

#include <dune/fufem/hdf5/hdf5-sequence-io.hh>
#include <dune/fufem/hdf5/hdf5-singleton-writer.hh>

template <class ProgramState, class GridView> class FrictionalBoundaryWriter {
  using ScalarVector = typename ProgramState::ScalarVector;
  using Vector = typename ProgramState::Vector;
  using Patch = BoundaryPatch<GridView>;

public:
  FrictionalBoundaryWriter(HDF5Grouplike &file, Vector const &vertexCoordinates,
                           Patch const &frictionalBoundary);

  template <class Friction>
  void write(ProgramState const &programState, Friction &friction);

private:
  HDF5Group group_;

  Patch const &frictionalBoundary_;

  HDF5SequenceIO<2> frictionalBoundaryDisplacementWriter_;
  HDF5SequenceIO<2> frictionalBoundaryVelocityWriter_;
  HDF5SequenceIO<1> frictionalBoundaryStateWriter_;
  HDF5SequenceIO<1> frictionalBoundaryCoefficientWriter_;
};
#endif
