#ifndef SRC_HDF_SURFACE_WRITER_HH
#define SRC_HDF_SURFACE_WRITER_HH

#include <dune/fufem/boundarypatch.hh>

#include <dune/fufem/hdf5/hdf5-sequence-io.hh>
#include <dune/fufem/hdf5/hdf5-singleton-writer.hh>

template <class ProgramState, class GridView> class SurfaceWriter {
  using Vector = typename ProgramState::Vector;
  using Patch = BoundaryPatch<GridView>;

public:
  SurfaceWriter(HDF5Grouplike &file, Vector const &vertexCoordinates,
                Patch const &surface);

  void write(ProgramState const &programState);

private:
  HDF5Group group_;

  Patch const &surface_;

  HDF5SequenceIO<2> surfaceDisplacementWriter_;
  HDF5SequenceIO<2> surfaceVelocityWriter_;
};
#endif
